import { Config } from './config';
import { EventEmitter } from '@angular/core';
import { NodeState } from './node-state';
import { NodeLevelConfig } from './node-level-config';
export declare class Node {
    private _name;
    private _value;
    private _children;
    private _progress;
    private _nodeState;
    private _nodeLevelConfig;
    private config;
    private loadChildrenEvent;
    /**
     * recursively sets prototype Node on the object and its children
     *
     * @param node
     */
    static nodify(obj: any): Node;
    static toNodeArray(objArr: any[]): Node[];
    private _parent;
    constructor(_name: string, _value: any, _children: Node[], _progress?: boolean, _nodeState?: NodeState, _nodeLevelConfig?: NodeLevelConfig);
    get name(): string;
    set name(name: string);
    get value(): any;
    set value(value: any);
    get children(): Node[];
    set children(children: Node[]);
    loadChildren(children: any[]): void;
    addChild(child: Node): void;
    get progress(): boolean;
    set progress(progress: boolean);
    get nodeState(): NodeState;
    set nodeState(nodeState: NodeState);
    get nodeLevelConfig(): NodeLevelConfig;
    set nodeLevelConfig(nodeLevelConfig: NodeLevelConfig);
    get parent(): Node;
    set parent(node: Node);
    setConfigRecursively(config: Config): void;
    verifyStateRecursive(): void;
    changeChildrenRecursive(): void;
    checkImmediateChildren(): void;
    getCheckedValues(): Node[];
    expandAndShowParentRecursively(): void;
    filter(text: string, loadChildren: EventEmitter<Node>): boolean;
    unHideChildren(): void;
    setCheckedRecursively(checked: boolean): void;
    removeMe(): void;
    search(): void;
}
