import { SpTreeviewNodeTemplate } from './sp-treeview-node-template';
import { EventEmitter } from '@angular/core';
import { MatRadioChange } from '@angular/material/radio';
import { MatCheckboxChange } from '@angular/material/checkbox';
import { Config } from './config';
import { Node } from './node';
export declare class SpTreeviewNodeTemplateContext implements SpTreeviewNodeTemplate {
    node: Node;
    config: Config;
    radioSelect: EventEmitter<Node[]>;
    checkboxSelect: EventEmitter<null>;
    delete: EventEmitter<Node>;
    addChild: EventEmitter<Node>;
    loadChildren: EventEmitter<Node>;
    selectParent: EventEmitter<Node>;
    constructor();
    onCollapseExpand: (node: Node) => void;
    onDelete: (node: Node) => void;
    onAddChild: (node: Node) => void;
    onLoadChildren: (node: Node) => void;
    onRadioChange: (event: MatRadioChange) => void;
    /**
     * called when the checkbox value is changed
     * sets checked value recursively
     */
    onCheckChange: (event: MatCheckboxChange) => void;
}
