import { EventEmitter, OnInit, TemplateRef } from '@angular/core';
import { Config } from '../model/config';
import { Node } from '../model/node';
import { SpTreeviewNodeTemplate } from '../model/sp-treeview-node-template';
import { SpTreeviewNodeTemplateContext } from '../model/sp-treeview-node-template-context';
import * as i0 from "@angular/core";
export declare class SpTreeviewNodeComponent implements OnInit {
    SELECT_CHECKBOX: number;
    SELECT_RADIO: number;
    SELECT_NONE: number;
    CHECKED: number;
    UNCHECKED: number;
    INDETERMINATE: number;
    template: TemplateRef<SpTreeviewNodeTemplate>;
    contextPrototype: any;
    node: Node;
    config: Config;
    radioSelect: EventEmitter<Node[]>;
    checkboxSelect: EventEmitter<null>;
    delete: EventEmitter<Node>;
    addChild: EventEmitter<Node>;
    loadChildren: EventEmitter<Node>;
    selectParent: EventEmitter<Node>;
    dereference: EventEmitter<Node>;
    context: SpTreeviewNodeTemplateContext;
    renameNode: EventEmitter<Node>;
    constructor();
    ngOnInit(): void;
    onDelete: (node: Node) => void;
    onAddChild: (node: Node) => void;
    onLoadChildren: (node: Node) => void;
    onSelectParent: (node: Node) => void;
    onRadioChange(nodes: Node[]): void;
    onCheckChange(nodes: Node[]): void;
    search(text: string): boolean;
    onDereference(node: Node): void;
    onRenameNode(node: any): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<SpTreeviewNodeComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<SpTreeviewNodeComponent, "sp-treeview-node", never, { "template": "template"; "contextPrototype": "contextPrototype"; "node": "node"; "config": "config"; }, { "radioSelect": "radioSelect"; "checkboxSelect": "checkboxSelect"; "delete": "delete"; "addChild": "addChild"; "loadChildren": "loadChildren"; "selectParent": "selectParent"; "dereference": "dereference"; "renameNode": "renameNode"; }, never, never>;
}
