import { EventEmitter, OnDestroy, OnInit, QueryList, TemplateRef } from '@angular/core';
import { MatCheckboxChange } from '@angular/material/checkbox';
import { MatRadioChange } from '@angular/material/radio';
import { Config } from '../model/config';
import { Node } from '../model/node';
import { SpTreeviewNodeTemplate } from '../model/sp-treeview-node-template';
import { SpTreeviewNodeTemplateContext } from '../model/sp-treeview-node-template-context';
import { SpTreeviewNodeComponent } from '../sp-treeview-node/sp-treeview-node.component';
import * as i0 from "@angular/core";
export declare class SpTreeviewComponent implements OnInit, OnDestroy {
    searchString: string;
    SELECT_CHECKBOX: number;
    SELECT_RADIO: number;
    SELECT_NONE: number;
    CHECKED: number;
    UNCHECKED: number;
    INDETERMINATE: number;
    all: any;
    nodes: Node[];
    customSearch: boolean;
    customRootText: string;
    config: Config;
    template: TemplateRef<SpTreeviewNodeTemplate>;
    contextPrototype: SpTreeviewNodeTemplateContext;
    change: EventEmitter<Node[]>;
    delete: EventEmitter<Node>;
    addChild: EventEmitter<Node>;
    loadChildren: EventEmitter<Node>;
    selectParent: EventEmitter<Node>;
    search: EventEmitter<string>;
    searchTo: EventEmitter<string>;
    dereference: EventEmitter<Node>;
    editNode: EventEmitter<Node>;
    trees: QueryList<SpTreeviewNodeComponent>;
    renameNode: EventEmitter<Node>;
    constructor();
    ngOnInit(): void;
    getSelectedValues(): Node[];
    onSearch(event: any): void;
    applySearch(event: any): void;
    onChange(nodes: Node[]): void;
    onDelete(node: Node): void;
    onEditNode(node: any): void;
    onAddChild(node: Node): void;
    onLoadChildren(node: Node): void;
    onSelectParent(node: Node): void;
    onAllRadioChange(event: MatRadioChange): void;
    onAllCheckChange(event: MatCheckboxChange): void;
    onAddRoot(): void;
    ngOnDestroy(): void;
    onDereference(node: Node): void;
    onRenameNode(node: any): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<SpTreeviewComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<SpTreeviewComponent, "sp-treeview", never, { "nodes": "nodes"; "customSearch": "customSearch"; "customRootText": "customRootText"; "config": "config"; "template": "template"; "contextPrototype": "contextPrototype"; }, { "change": "change"; "delete": "delete"; "addChild": "addChild"; "loadChildren": "loadChildren"; "selectParent": "selectParent"; "search": "search"; "searchTo": "searchTo"; "dereference": "dereference"; "editNode": "editNode"; "renameNode": "renameNode"; }, never, never>;
}
